(**************************************************************************

     $RCSfile: Bullet.mod $
  Description: Interface to bullet.library

   Created by: fjc (Frank Copeland)
    $Revision: 3.1 $
      $Author: fjc $
        $Date: 1994/08/08 01:14:19 $

  $VER: bullet_protos.h 38.0 (19.6.92)
  Includes Release 40.15

  (C) Copyright 1990-1993 Commodore-Amiga, Inc.
      All Rights Reserved

  Oberon-A Interface Copyright  1994, Frank Copeland.
  This file is part of the Oberon-A Interface.
  See Oberon-A.doc for conditions of use and distribution.

*************************************************************************)

MODULE Bullet;

(*
** $C- CaseChk       $I- IndexChk  $L+ LongAdr   $N- NilChk
** $P- PortableCode  $R- RangeChk  $S- StackChk  $T- TypeChk
** $V- OvflChk       $Z- ZeroVars
*)

IMPORT
  E := Exec,
  U := Utility,
  DF := DiskFont,
  SYS := SYSTEM;


(**-- Library Base variable --------------------------------------------*)

CONST

  name * = "bullet.library";

TYPE

  BulletBasePtr* = CPOINTER TO BulletBase;
  BulletBase* = RECORD (E.Library) END;

VAR

  base* : BulletBasePtr;


(**-- Library Functions ------------------------------------------------*)

LIBCALL (base : BulletBasePtr) OpenEngine * ()
  : DF.GlyphEnginePtr;
  -30;
LIBCALL (base : BulletBasePtr) CloseEngine *
  ( glyphEngine [8] : DF.GlyphEnginePtr );
  -36;
LIBCALL (base : BulletBasePtr) SetInfoA *
  ( glyphEngine [8] : DF.GlyphEnginePtr;
    tagList     [9] : ARRAY OF U.TagItem )
  : BOOLEAN;
  -42;
LIBCALL (base : BulletBasePtr) SetInfo *
  ( glyphEngine [8]  : DF.GlyphEnginePtr;
    tagList     [9]..: U.Tag )
  : BOOLEAN;
  -42;
LIBCALL (base : BulletBasePtr) ObtainInfoA *
  ( glyphEngine [8] : DF.GlyphEnginePtr;
    tagList     [9] : ARRAY OF U.TagItem )
  : BOOLEAN;
  -48;
LIBCALL (base : BulletBasePtr) ObtainInfo *
  ( glyphEngine [8]  : DF.GlyphEnginePtr;
    tagList     [9]..: U.Tag )
  : BOOLEAN;
  -48;
LIBCALL (base : BulletBasePtr) ReleaseInfoA *
  ( glyphEngine [8] : DF.GlyphEnginePtr;
    tagList     [9] : ARRAY OF U.TagItem )
  : BOOLEAN;
  -54;
LIBCALL (base : BulletBasePtr) ReleaseInfo *
  ( glyphEngine [8]  : DF.GlyphEnginePtr;
    tagList     [9]..: U.Tag )
  : BOOLEAN;
  -54;

(**-- Library Base variable --------------------------------------------*)

(**-----------------------------------*)
PROCEDURE* CloseLib ();

BEGIN (* CloseLib *)
  IF base # NIL THEN E.base.CloseLibrary (base) END
END CloseLib;

(**-----------------------------------*)
PROCEDURE OpenLib * (mustOpen : BOOLEAN);

BEGIN (* OpenLib *)
  IF base = NIL THEN
    base :=
      SYS.VAL (
        BulletBasePtr,
        E.base.OpenLibrary (name, E.libraryMinimum));
    IF base # NIL THEN SYS.SETCLEANUP (CloseLib)
    ELSIF mustOpen THEN HALT (100)
    END;
  END;
END OpenLib;

BEGIN
  base := NIL
END Bullet.
