(***************************************************************************

     $RCSfile: GamePort.mod $
  Description: Interface to gameport.device

   Created by: fjc (Frank Copeland)
    $Revision: 3.2 $
      $Author: fjc $
        $Date: 1994/08/08 00:46:06 $

  $VER: gameport.h 36.1 (5.11.90)
  Includes Release 40.15

  (C) Copyright 1985-1993 Commodore-Amiga, Inc.
      All Rights Reserved

  Oberon-A interface Copyright  1994, Frank Copeland.
  This file is part of the Oberon-A Interface.
  See Oberon-A.doc for conditions of use and distribution.

***************************************************************************)

MODULE GamePort;

(*
** $C- CaseChk       $I- IndexChk  $L+ LongAdr   $N- NilChk
** $P- PortableCode  $R- RangeChk  $S- StackChk  $T- TypeChk
** $V- OvflChk       $Z- ZeroVars
*)

IMPORT E := Exec;


(*
**      GamePort device command definitions
*)


CONST

(******  GamePort commands ******)
  readEvent     * = E.cmdNonstd+0;
  askCType      * = E.cmdNonstd+1;
  setCType      * = E.cmdNonstd+2;
  askTrigger    * = E.cmdNonstd+3;
  setTrigger    * = E.cmdNonstd+4;

(******  GamePort structures ******)

(* GamePortTrigger.keys *)
  gptDownKeys     * = 0;
  gptUpKeys       * = 1;

TYPE

  GamePortTriggerPtr * = CPOINTER TO GamePortTrigger;
  GamePortTrigger * = RECORD
    keys *    : E.WSET;       (* key transition triggers *)
    timeout * : E.UWORD;      (* time trigger (vertical blank units) *)
    xDelta *  : E.UWORD;      (* X distance trigger *)
    yDelta *  : E.UWORD;      (* Y distance trigger *)
  END; (* GamePortTrigger *)

CONST

(****** Controller Types ******)
  ctAllocated    * = -1;    (* allocated by another user *)
  ctNoController * = 0;

  ctMouse        * = 1;
  ctRelJoystick  * = 2;
  ctAbsJoystick  * = 3;


(****** Errors ******)
  errSetCType    * = 1;     (* this controller not valid at this time *)


CONST

  name * = "gameport.device";

END GamePort.
